<%@ Control Language="vb" Inherits="CommunityServer.ControlPanel.UI.BaseBlogControl" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="CommunityServer.BlogML" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Xml" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.IO.Compression" %>
<%@ Register TagPrefix="CS" Namespace="CommunityServer.Controls" Assembly="CommunityServer.Controls" %>
<%@ Import Namespace="CommunityServer.Components" %>
<%@ Import Namespace="CommunityServer.ControlPanel.UI" %>
<%@ Import Namespace="CommunityServer.Controls" %>

<script language="vb" runat="server">
    Private Sub btnExport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim AppKey As String = MyBase.CurrentWeblog.ApplicationKey.ToString()
        
        Dim w As CommunityServer.Blogs.Components.Weblog = CommunityServer.Blogs.Components.Weblogs.GetWeblog(AppKey)
        
        If w Is Nothing Then
            Response.Write("Cannot find Weblog , AppKey : " + AppKey)
            Response.End()
            Exit Sub
        ElseIf w.Owners.Length <= 0 Then
            Response.Write("You must assgin a Blog Owner")
            Response.End()
            Exit Sub
        End If
        
        Dim timeout = Server.ScriptTimeout
        Try
            Server.ScriptTimeout = 900
            
            Response.Buffer = False
            Response.Clear()
            Response.ContentType = "application/xml"
            Response.AppendHeader("Content-Disposition", "attachment; filename=BlogML.xml")
                
            Dim Output As Stream = Response.OutputStream
            
            Dim ZipStream As GZipStream = New GZipStream(Response.OutputStream, _
                CompressionMode.Compress)
            Response.AppendHeader("Content-Encoding", "gzip")
            Output = ZipStream
      
            Dim Utf8 As New UTF8Encoding(False)
            Dim Writer As XmlTextWriter = New XmlTextWriter(Output, Utf8)
            Writer.Formatting = Formatting.Indented
                               
            Dim objBlogML As New CommunityServer.BlogML.CommunityServer.BlogML.Writer(AppKey)

            objBlogML.Write(Writer)

            Writer.Flush()
            Writer.Close()
            Response.End()
        Catch ex As Exception
        Finally
            Server.ScriptTimeout = timeout
        End Try
    End Sub
    
    Private Sub btnImport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim AppPath As String = Request.PhysicalApplicationPath
        Dim AppKey As String = MyBase.CurrentWeblog.ApplicationKey.ToString()
        Dim Path As String = AppPath + "blogs\files\" + AppKey + "-BlogML.xml"


        If Not (MyFile.PostedFile Is Nothing) Then
            MyFile.PostedFile.SaveAs(Path)
        End If


        Dim objBlogMLReader As New CommunityServer.BlogML.CommunityServer.BlogML.Reader(AppKey)

        If IO.File.Exists(Path) = True Then
            Using Reader As New IO.StreamReader(IO.File.Open(Path, IO.FileMode.Open))
                Dim XML As String = Reader.ReadToEnd

                'If you want to clear all old items send True as second parameter.
                objBlogMLReader.LoadBlog(XML, False)
                'objBlogMLReader.LoadBlog(XML, True)

                lblBlogMLResult.ForeColor = Drawing.Color.Green
                lblBlogMLResult.Text = "Your BlogML file is imported successfully."
            End Using
            File.Delete(Path)
        Else
            lblBlogMLResult.Text = "Your file does not exist."
        End If
    End Sub
</script>

<div>
    <h4>
        Export/Import your content based on <a href="http://blogml.com">BlogML</a> standard</h4>
    <p>
        Attention: First back up your database!</p>
    <input type="file" runat="server" id="MyFile">
    <asp:Button ID="btnImport" runat="server" OnClick="btnImport_Click" Text="Import"></asp:Button>
    <asp:Button ID="btnExport" runat="server" OnClick="btnExport_Click" Text="Export"></asp:Button>
    <asp:Label ID="lblBlogMLResult" runat="server"></asp:Label>
</div>
