﻿<%@ Page EnableViewState="false" Language="C#" AutoEventWireup="true" %>

<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="CommunityServer.BlogML" %>
<%@ Import Namespace="System.Xml" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.IO.Compression" %>
<%@ Import Namespace="CommunityServer.Components" %>
<%@ Import Namespace="CommunityServer.Blogs.Components" %>

<script runat="server" language="C#">

    private void btnImport_Click(object sender, EventArgs e)
    {

        CSContext context = CSContext.Current;
        int sectionID = context.GetIntFromQueryString("SectionID", -1);
        Weblog w = Weblogs.GetWeblog(sectionID, false, false);
        String AppKey = w.ApplicationKey;

        string AppPath = Request.PhysicalApplicationPath;
        string Path = AppPath + "blogs\\files\\" + AppKey + "-BlogML.xml";

        if (FileUpload1.PostedFile != null)
            FileUpload1.PostedFile.SaveAs(Path);
        
        CommunityServer.BlogML.Reader objBlogMLReader = new CommunityServer.BlogML.Reader(AppKey);

        if (File.Exists(Path))
        {
            using (StreamReader Reader = new StreamReader(File.Open(Path, FileMode.Open)))
            {
                String XML = Reader.ReadToEnd();
                string Output;

                Output = objBlogMLReader.LoadBlog(XML, ClearPost.Checked);

                Label1.ForeColor = System.Drawing.Color.Green;
                Label1.Text = "Your BlogML file is imported successfully.<br/><br/>Result:" + Output;
            }
            File.Delete(Path);
        }
        else
            Label1.Text = "Your file does not exist.";
    }
</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>BlogML Import</title>
</head>
<body>
    <form runat="server" id="form1">
    <table bgcolor="red" border="0">
    <tr>
    <td>
    <a href="Blogs.aspx"><font color="white"><strong>&lt;&lt; Return to Blogs Admin</strong></font></a>
    </td>
    </tr>
    </table>
    <br />
    This page can import <a href="http://blogml.org/">BlogML</a> file to your Blog.
    <br />
    <br />
    Upload File :<asp:FileUpload ID="FileUpload1" runat="server" />
    <br />
    <br />
    Clear current post?
    <asp:CheckBox ID="ClearPost" runat="server" />
    <br />
    <br />
    <asp:Button ID="Button1" runat="server" Text="Run Import" OnClick="btnImport_Click" />
    <br />
    <br />
    Result:
    <br />
    <asp:Label ID="Label1" runat="server" Text=""></asp:Label>
    </form>
</body>
</html>
