﻿<%@ Page EnableViewState="false" Language="C#" AutoEventWireup="true" %>

<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="CommunityServer.BlogML" %>
<%@ Import Namespace="System.Xml" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.IO.Compression" %>
<%@ Import Namespace="CommunityServer.Components" %>
<%@ Import Namespace="CommunityServer.Blogs.Components" %>

<script runat="server" language="C#">

    void Page_Load()
    {
        btnExport_Click();
    }

    public void btnExport_Click()
    {

        CSContext context = CSContext.Current;
        int sectionID = context.GetIntFromQueryString("SectionID", -1);

        Weblog w = Weblogs.GetWeblog(sectionID, false, false);
        if (w == null)
            Response.Write(string.Format("SectionID = {0} , Weblog is not find!", sectionID));
        else if(w.OwnerArray.Length <=0)
        {
            Response.Write("<font color=\"red\"><b>Error !!</b></font><br /><br />");
            Response.Write("Blog must have at least one owner! Please assign least one or more authors.<br /><br /");
            Response.Write("<a href=\"blogs.aspx\">Return Manage Blogs page</a>");
        }
        else
        {
            String AppKey = w.ApplicationKey;
            try
            {
                Response.Buffer = false;
                Response.Clear();
                Response.ContentType = "application/xml";
                Response.AppendHeader("Content-Disposition", "attachment; filename=BlogML.xml");

                Stream Output = Response.OutputStream;

                GZipStream ZipStream = new GZipStream(Response.OutputStream, CompressionMode.Compress);
                Response.AppendHeader("Content-Encoding", "gzip");
                Output = ZipStream;

                UTF8Encoding Utf8 = new UTF8Encoding(false);
                XmlTextWriter Writer = new XmlTextWriter(Output, Utf8);
                Writer.Formatting = Formatting.Indented;

                CommunityServer.BlogML.Writer objBlogML = new CommunityServer.BlogML.Writer(AppKey);

                objBlogML.Write(Writer);

                Writer.Flush();
                Writer.Close();
            }
            catch (Exception ex)
            {
                Response.Write(ex.ToString());
            }
        }
    }

</script>