using System;
using System.Collections.Generic;
using System.Text;
using CookComputing.XmlRpc;

// Based on code from http://msdn2.microsoft.com/en-us/library/aa905670.aspx
namespace LiveSpace.BlogML.MetaWeblogApi
{
    /// <summary> 
    /// This struct represents the information about a post that could be returned by the 
    /// editPost(), getRecentPosts() and getPost() methods. 
    /// </summary> 
    [XmlRpcMissingMapping(MappingAction.Error)]
    public struct Post
    {
        public DateTime dateCreated;
        public string description;
        public string title;
        public string postid;
        public string[] categories;
        public bool publish;

        public Post(string postid, string title, string description, string[] categories, DateTime dateCreated, bool publish)
        {
            this.postid = postid;
            this.title = title;
            this.description = description;
            this.categories = categories;
            this.dateCreated = dateCreated;
            this.publish = publish;
        }
    }
}
