using System;
using System.Collections.Generic;
using System.Text;
using RssToolkit;
using BlogML.Xml;

namespace Rss2BlogML
{
	public interface IRssMapper
	{
		string GeneratePostId(GenericRssElement rssElement);
		string GenerateCommentId(GenericRssElement rssElement);
		IdStruct GenerateAuthorId(GenericRssElement rssElement);
		CatStruct[] GenerateCategoryIds(GenericRssElement rssElement);
		string GenerateTrackbackId(GenericRssElement rssElement);
		string GeneratePostName(GenericRssElement rssElement);
	}

	public struct IdStruct
	{
		public string Id;
		public bool IsNewId;

		public IdStruct(string id, bool isNewId)
		{
			Id = id;
			IsNewId = isNewId;
		}
	}

	public struct CatStruct
	{
		public string Id;
		public string Name;
		public bool IsNewId;

		public CatStruct(string name, string id, bool isNewId)
		{
			Id = id;
			Name = name;
			IsNewId = isNewId;
		}
	}


}


