using System;
using System.Collections.Generic;
using System.Text;

namespace Rss2BlogML
{
	internal static class Parsers
	{
		internal static string ParseString(Dictionary<string, string> attributes, string key)
		{
			if (attributes.ContainsKey(key))
				return attributes[key];
			else
				return string.Empty;
		}

		internal static int ParseInt(Dictionary<string, string> attributes, string key)
		{
			if (attributes.ContainsKey(key))
				return Convert.ToInt32(attributes[key]);
			else
				return 0;
		}

		internal static DateTime ParseDateTime(Dictionary<string, string> attributes, string key)
		{
			if (attributes.ContainsKey(key))
				return DateTime.Parse(attributes[key]);
			else
				return DateTime.MinValue;
		}

		internal static string StripDomainFromUrl(string url)
		{
			Uri uri = new Uri(url);
			return uri.AbsolutePath;
		}
	}
}
