<?php
require_once ('admin.php');
$title = __('Export');
$parent_file = 'edit.php';

if ( isset( $_GET['download'] ) )
	export_wp();

require_once ('admin-header.php');
set_time_limit(180);
?>

<div class="wrap">
<h2><?php _e('Export'); ?></h2>
<div class="narrow">
<p><?php _e('When you click the button below WordPress will create an XML file for you to save to your computer.'); ?></p>
<p><?php _e('This format, which is called BlogML, will contain your posts, comments, custom fields, and categories.'); ?></p>
<p><?php _e('Once you&#8217;ve saved the download file, you can use BlogML runtime to import the contents of this blog to any number of other blog engines.'); ?></p>
<form action="" method="get">
<h3><?php _e('Optional options'); ?></h3>

<table>
<tr>
<th><?php _e('Restrict Author:'); ?></th>
<td>
<select name="author">
<option value="all" selected="selected"><?php _e('All'); ?></option>
<?php
$authors = $wpdb->get_col( "SELECT post_author FROM $wpdb->posts GROUP BY post_author" );  
foreach ( $authors as $id ) {
	$o = get_userdata( $id );
	echo "<option value='$o->ID'>$o->display_name</option>";
}
?>
</select>
</td>
</tr>
</table>
<p class="submit"><input type="submit" name="submit" value="<?php _e('Download Export File'); ?> &raquo;" />
<input type="hidden" name="download" value="true" />
</p>
</form>
</div>
</div>

<?php

function export_wp() {
global $wpdb, $posts, $post;

$filename = 'wordpress.' . date('Y-m-d') . '.xml';

header('Content-Description: File Transfer');
header("Content-Disposition: attachment; filename=$filename");
header('Content-type: text/xml; charset=' . get_option('blog_charset'), true);

$where = '';
if ( isset( $_GET['author'] ) && $_GET['author'] != 'all' ) {
	$author_id = (int) $_GET['author'];
	$where = " WHERE post_author = '$author_id' ";
}

$posts = $wpdb->get_results("SELECT * FROM $wpdb->posts $where ORDER BY post_date_gmt ASC");

$categories = (array) $wpdb->get_results("SELECT cat_ID, cat_name, category_nicename, category_description, category_parent, posts_private, links_private FROM $wpdb->categories LEFT JOIN $wpdb->post2cat ON (category_id = cat_id) LEFT JOIN $wpdb->posts ON (post_id <=> id) $where GROUP BY cat_id");

function wxr_missing_parents($categories) {
	if ( !is_array($categories) || empty($categories) )
		return array();

	foreach ( $categories as $category )
		$parents[$category->cat_ID] = $category->category_parent;

	$parents = array_unique(array_diff($parents, array_keys($parents)));

	if ( $zero = array_search('0', $parents) )
		unset($parents[$zero]);

	return $parents;
}

while ( $parents = wxr_missing_parents($categories) ) {
	$found_parents = $wpdb->get_results("SELECT cat_ID, cat_name, category_nicename, category_description, category_parent, posts_private, links_private FROM $wpdb->categories WHERE cat_ID IN (" . join(', ', $parents) . ")");
	if ( is_array($found_parents) && count($found_parents) )
		$categories = array_merge($categories, $found_parents);
	else
		break;
}

// Put them in order to be inserted with no child going before its parent
$pass = 0;
$passes = 1000 + count($categories);
while ( ( $cat = array_shift($categories) ) && ++$pass < $passes ) {
	if ( $cat->category_parent == 0 || isset($cats[$cat->category_parent]) ) {
		$cats[$cat->cat_ID] = $cat;
	} else {
		$categories[] = $cat;
	}
}
unset($categories);

function blogml_posttype($str) {
	if ($str = "post")
		return "normal";
	else
		return "article";
}

function blogml_isapproved($str) {
	if ($str = 0)
		return "false";
	else
		return "true";
}


print '<?xml version="1.0" encoding="' . get_bloginfo('charset') . '"?' . ">\n";

?>

<!--
	This is a BlogML file generated by WordPress BlogML Export 1.0 as an export of 
	your blog. It contains information about your blog's posts, comments, and 
	categories. You may use this file to transfer that content from one site to 
	another. This file is not intended to serve as a complete backup of your 
	blog.
	
	After you've generated this file, you should go to http://www.blogml.com to
	download the tool that will let you import this file into your new blog.
-->

<!-- generator="WordPress BlogML Export 1.0 by Robert McLaws" created="<?php echo date('Y-m-d H:m'); ?>"-->
<blog root-url="test"
	date-created="<?php echo date('Y-m-d'); ?>T<?php echo date('H:m:s'); ?>"
	xmlns="http://www.blogml.com/2006/09/BlogML"
>
	<title type="text"><![CDATA[<?php bloginfo_rss('name'); ?>]]></title>
	<sub-title type="text"><![CDATA[<?php bloginfo_rss("description") ?>]]></sub-title>
<?php
$authors = $wpdb->get_results("SELECT * FROM $wpdb->users WHERE $wpdb->users.ID IN (SELECT DISTINCT post_author FROM $wpdb->posts) ORDER BY $wpdb->users.ID");
if ( $authors ) { ?>
	<authors>
<?php foreach ( $authors as $w ) { 
$formattedAuthorDate = date("Y-m-d", strtotime($w->user_registered))."T".date("H:m:s", strtotime($w->user_registered));
?>
		<author id="<?php echo $w->ID; ?>" date-created="<?php echo $formattedAuthorDate; ?>" approved="true" email="<?php echo $w->user_email; ?>" />
<?php } ?>
	</authors>
<?php } ?>

<?php if ( $cats ) : ?>
	<categories>
<?php foreach ( $cats as $c ) : ?>
		<category id="<?php echo $c->cat_ID; ?>" approved="true" description="<?php echo $c->category_description; ?>" parentref="<?php echo $c->category_parent ? $cats[$c->category_parent]->cat_ID : '0'; ?>">
			<title type="text"><![CDATA[<?php echo $c->cat_name; ?>]]></title>
		</category>
<?php endforeach; ?>
	</categories>
<?php endif; ?>


	<?php if ($posts) { ?>
	<posts>

<?php foreach ($posts as $post) { start_wp(); 

$formattedPostDate = date("Y-m-d", strtotime($post->post_date))."T".date("H:m:s", strtotime($post->post_date));
$formattedModifiedDate = date("Y-m-d", strtotime($post->post_modified))."T".date("H:m:s", strtotime($post->post_modified));
$hasexcerpt = $post->post_excerpt ? 'true' : 'false';
?>
		<post id="<?php echo $post->ID; ?>" date-created="<?php echo $formattedPostDate; ?>" date-modified="<?php echo $formattedModifiedDate; ?>" post-url="<?php echo $post->post_name; ?>" type="<?php echo blogml_posttype($post->post_type); ?>" hasexcerpt="<?php echo $hasexcerpt; ?>" views="0">
			<title type="text"><![CDATA[<?php the_title_rss() ?>]]></title>
			<content type="text"><![CDATA[<?php echo $post->post_content ?>]]></content>
			<post-name type="text"><![CDATA[<?php echo $post->post_name; ?>]]></post-name>
			<?php if ($hasexcerpt == "true") { ?>
			<excerpt type="text"><![CDATA[<?php echo $post->post_excerpt; ?>]]></excerpt>
			<?php } ?>
			<authors>
				<author ref="<?php echo $post->post_author ?>" />
			</authors>


<?php
$catlist = $wpdb->get_results("SELECT * FROM $wpdb->post2cat WHERE post_id = $post->ID");
if ( $catlist ) { ?>
			<categories>

<?php foreach ( $catlist as $a ) { ?>
				<category ref="<?php echo $a->category_id; ?>" />
<?php } ?>
			</categories>
<?php } ?>

<?php
$comments = $wpdb->get_results("SELECT * FROM $wpdb->comments WHERE comment_type = '' AND comment_approved != 'spam' AND comment_post_ID = $post->ID");
if ( $comments ) { ?>
			<comments>

<?php foreach ( $comments as $c ) { 
$commentdate = date("Y-m-d", strtotime($c->comment_date))."T".date("H:m:s", strtotime($c->comment_date));
?>
				<comment id="<?php echo $c->comment_ID; ?>" date-created="<?php echo $commentdate; ?>" user-name="<?php echo $c->comment_author; ?>" user-url="<?php echo $c->comment_author_url; ?>" approved="<?php echo blogml_isapproved($c->comment_approved); ?>">
					<content type="text"><![CDATA[<?php echo $c->comment_content; ?>]]></content>
				</comment>
<?php } ?>
			</comments>
<?php } ?>

<?php
$trackbacks = $wpdb->get_results("SELECT * FROM $wpdb->comments WHERE comment_type = 'trackback' AND comment_approved != 'spam' AND comment_post_ID = $post->ID");
if ( $trackbacks ) { ?>
			<trackbacks>

<?php foreach ( $trackbacks as $t ) { 
$trackbackdate = date("Y-m-d", strtotime($t->comment_date))."T".date("H:m:s", strtotime($t->comment_date));
?>
				<trackback id="<?php echo $t->comment_ID; ?>" date-created="<?php echo $trackbackdate; ?>" approved="<?php echo blogml_isapproved($t->comment_approved); ?>" url="<?php echo $t->comment_author_url; ?>">
					<content type="text"><![CDATA[<?php echo $t->comment_content; ?>]]></content>
				</trackback>
<?php } ?>
			</trackbacks>

<?php } ?>
		</post>
<?php } } ?>
	</posts>
</blog>
<?php
	die();
}

include ('admin-footer.php');
?>