﻿// The following code was generated by Microsoft Visual Studio 2005.
// The test owner should check each test for validity.
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;
using System.Collections.Generic;
using BlogML.Xml;
namespace BlogMLUnitTest
{
    /// <summary>
    ///This is a test class for BlogML.Xml.BlogMLContent and is intended
    ///to contain all BlogML.Xml.BlogMLContent Unit Tests
    ///</summary>
    [TestClass()]
    public class BlogMLContentTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Base64
        ///</summary>
        [TestMethod()]
        public void Base64Test()
        {
            BlogMLContent target = new BlogMLContent();

            // Base64 = false
            bool val = false;

            target.Base64 = val;

            Assert.AreEqual(val, target.Base64,
                "BlogML.Xml.BlogMLContent.Base64 was not set correctly(Base64 = false).");

            // Base64 = true
            val = true;
            target.Base64 = val;

            Assert.AreEqual(val, target.Base64,
                "BlogML.Xml.BlogMLContent.Base64 was not set correctly(Base64 = true).");
        }

        /// <summary>
        ///A test for Create (string, bool)
        ///</summary>
        [TestMethod()]
        public void CreateTest()
        {
            // Base64 = false & normal text
            string text = "This is a text value!";

            bool base64 = false;

            BlogMLContent expected = new BlogMLContent();
            expected.Text = text;
            expected.Base64 = base64;

            BlogMLContent actual;

            actual = BlogML.Xml.BlogMLContent.Create(text, base64);

            Assert.AreEqual(expected, actual,
                "BlogML.Xml.BlogMLContent.Create did not return the expected value(Base64 = false & normal text).");

            // Base64 = false & markup text
            text = "<element>This is a text value!</element>";

            base64 = false;

            expected = new BlogMLContent();
            expected.Text = text;
            expected.Base64 = base64;

            actual = BlogML.Xml.BlogMLContent.Create(text, base64);

            Assert.AreEqual(expected, actual,
                "BlogML.Xml.BlogMLContent.Create did not return the expected value(Base64 = false & markup text).");


            // Base64 = true & normal text
            text = "This is a text value!";

            base64 = true;

            expected = new BlogMLContent();

            byte[] byteArray = System.Text.Encoding.UTF8.GetBytes(text);
            expected.Text = Convert.ToBase64String(byteArray);
            expected.Base64 = base64;

            actual = BlogML.Xml.BlogMLContent.Create(text, base64);

            Assert.AreEqual(expected, actual,
                "BlogML.Xml.BlogMLContent.Create did not return the expected value(Base64 = true & normal text).");

            // Base64 = true & markup text
            text = "<element>This is a text value!</element>";

            base64 = true;

            expected = new BlogMLContent();

            byteArray = System.Text.Encoding.UTF8.GetBytes(text);
            expected.Text = Convert.ToBase64String(byteArray);
            expected.Base64 = base64;

            actual = BlogML.Xml.BlogMLContent.Create(text, base64);

            Assert.AreEqual(expected, actual,
                "BlogML.Xml.BlogMLContent.Create did not return the expected value(Base64 = true & markup text).");
        }

        /// <summary>
        ///A test for Text
        ///</summary>
        [TestMethod()]
        public void TextTest()
        {
            BlogMLContent target = new BlogMLContent();

            // Normal text
            string val = "This is a text value!";
            target.Text = val;

            Assert.AreEqual(val, target.Text,
                "BlogML.Xml.BlogMLContent.Text was not set correctly(normal text).");

            // Markup text
            val = "<element>This is a text value!</element>";
            target.Text = val;

            Assert.AreEqual(val, target.Text,
                "BlogML.Xml.BlogMLContent.Text was not set correctly(markup text).");
        }

        /// <summary>
        ///A test for UncodedText
        ///</summary>
        [TestMethod()]
        public void UncodedTextTest()
        {
            BlogMLContent target = new BlogMLContent();

            // Base64 = false & normal text
            target.Base64 = false;
            string val = "This is a text value!";
            target.Text = val;

            Assert.AreEqual(val, target.UncodedText,
                "BlogML.Xml.BlogMLContent.UncodedText was not set correctly(Base64 = false & normal text).");

            // Base64 = false & markup text
            target.Base64 = false;
            val = "<element>This is a text value!</element>";
            target.Text = val;

            Assert.AreEqual(val, target.UncodedText,
                "BlogML.Xml.BlogMLContent.UncodedText was not set correctly(Base64 = false & markup text).");

            // Base64 = true & normal text
            target.Base64 = true;
            val = "This is a text value!";
            byte[] byteArray = System.Text.Encoding.UTF8.GetBytes(val);
            target.Text = Convert.ToBase64String(byteArray);

            Assert.AreEqual(val, target.UncodedText,
                "BlogML.Xml.BlogMLContent.UncodedText was not set correctly(Base64 = true & normal text).");

            // Base64 = true & markup text
            target.Base64 = true;
            val = "<element>This is a text value!</element>";
            byteArray = System.Text.Encoding.UTF8.GetBytes(val);
            target.Text = Convert.ToBase64String(byteArray);

            Assert.AreEqual(val, target.UncodedText,
                "BlogML.Xml.BlogMLContent.UncodedText was not set correctly(Base64 = true & markup text).");
        }

        /// <summary>
        ///A test for Equals (object)
        ///</summary>
        [TestMethod()]
        public void EqualsTest()
        {
            // Equal
            BlogMLContent target = new BlogMLContent();
            string text = "This is a text value!";
            bool base64 = false;

            target.Text = text;
            target.Base64 = base64;

            object obj = target as object;

            bool expected = true;
            bool actual;

            actual = target.Equals(obj);

            Assert.AreEqual(expected, actual,
                "BlogML.Xml.BlogMLContent.Equals did not return the expected value(Equal).");

            // Not equal
            target = new BlogMLContent();
            text = "This is a text value!";
            base64 = false;

            target.Text = text;
            target.Base64 = base64;

            BlogMLContent myObj = new BlogMLContent();
            myObj.Text = "This is another text value!";
            myObj.Base64 = false;

            obj = myObj as object;

            expected = false;
            
            actual = target.Equals(obj);

            Assert.AreEqual(expected, actual,
                "BlogML.Xml.BlogMLContent.Equals did not return the expected value(Not Equal).");
        }
    }
}
