﻿// The following code was generated by Microsoft Visual Studio 2005.
// The test owner should check each test for validity.
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;
using System.Collections.Generic;
using BlogML.Xml;
using BlogML;
using System.IO;
namespace BlogMLUnitTest
{
    /// <summary>
    ///This is a test class for BlogML.Xml.BlogMLPost and is intended
    ///to contain all BlogML.Xml.BlogMLPost Unit Tests
    ///</summary>
    [TestClass()]
    public class BlogMLPostTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Attachments
        ///</summary>
        [TestMethod()]
        public void AttachmentsTest()
        {
            BlogMLPost target = new BlogMLPost();

            BlogMLPost.AttachmentCollection val = new BlogMLPost.AttachmentCollection();
            BlogMLAttachment attachment = new BlogMLAttachment();
            attachment.Embedded = true;
            attachment.MimeType = "image/jpeg";
            attachment.Data = File.ReadAllBytes(@"..\..\..\BlogMLUnitTest\Data\Image.jpg");

            val.Add(attachment);

            target.Attachments.Add(attachment);

            Assert.AreEqual(val, target.Attachments, "BlogML.Xml.BlogMLPost.Attachments was not set correctly.");
        }

        /// <summary>
        ///A test for Authors
        ///</summary>
        [TestMethod()]
        public void AuthorsTest()
        {
            BlogMLPost target = new BlogMLPost();

            BlogMLPost.AuthorReferenceCollection val = new BlogMLPost.AuthorReferenceCollection();
            BlogMLAuthorReference ref1 = new BlogMLAuthorReference();
            ref1.Ref = "5648";
            val.Add(ref1);

            BlogMLAuthorReference ref2 = new BlogMLAuthorReference();
            ref1.Ref = "5649";
            val.Add(ref2);

            Assert.AreEqual(val, target.Authors, "BlogML.Xml.BlogMLPost.Authors was not set correctly.");
        }

        /// <summary>
        ///A test for Categories
        ///</summary>
        [TestMethod()]
        public void CategoriesTest()
        {
            BlogMLPost target = new BlogMLPost();

            BlogMLPost.CategoryReferenceCollection val = new BlogMLPost.CategoryReferenceCollection();

            BlogMLCategoryReference ref1 = new BlogMLCategoryReference();
            ref1.Ref = "5500";
            target.Categories.Add(ref1);
            val.Add(ref1);

            BlogMLCategoryReference ref2 = new BlogMLCategoryReference();
            ref2.Ref = "5501";
            target.Categories.Add(ref2);
            val.Add(ref2);

            Assert.AreEqual(val, target.Categories, "BlogML.Xml.BlogMLPost.Categories was not set correctly.");
        }

        /// <summary>
        ///A test for Comments
        ///</summary>
        [TestMethod()]
        public void CommentsTest()
        {
            BlogMLPost target = new BlogMLPost();

            BlogMLPost.CommentCollection val = new BlogMLPost.CommentCollection();

            BlogMLComment comment1 = new BlogMLComment();
            comment1.Title = "Test";
            comment1.ID = "50";
            comment1.UserName = "Keyvan Nayyeri";
            target.Comments.Add(comment1);
            val.Add(comment1);

            BlogMLComment comment2 = new BlogMLComment();
            comment2.Title = "Test2";
            comment2.ID = "503";
            comment2.UserName = "Darren Neimke";
            target.Comments.Add(comment2);
            val.Add(comment2);

            Assert.AreEqual(val, target.Comments, "BlogML.Xml.BlogMLPost.Comments was not set correctly.");
        }

        /// <summary>
        ///A test for Content
        ///</summary>
        [TestMethod()]
        public void ContentTest()
        {
            BlogMLPost target = new BlogMLPost();

            BlogMLContent val = BlogMLContent.Create("<p>Sample Content!</p>", false);

            target.Content = val;


            Assert.AreEqual(val, target.Content, "BlogML.Xml.BlogMLPost.Content was not set correctly.");
        }

        /// <summary>
        ///A test for Excerpt
        ///</summary>
        [TestMethod()]
        public void ExcerptTest()
        {
            BlogMLPost target = new BlogMLPost();

            BlogMLContent val = BlogMLContent.Create("This is an excerpt.", false);

            target.Excerpt = val;

            Assert.AreEqual(val, target.Excerpt, "BlogML.Xml.BlogMLPost.Excerpt was not set correctly.");
        }

        /// <summary>
        ///A test for HasExcerpt
        ///</summary>
        [TestMethod()]
        public void HasExcerptTest()
        {
            BlogMLPost target = new BlogMLPost();

            bool val = false;

            target.HasExcerpt = val;

            Assert.AreEqual(val, target.HasExcerpt, "BlogML.Xml.BlogMLPost.HasExcerpt was not set correctly.");
        }

        /// <summary>
        ///A test for PostName
        ///</summary>
        [TestMethod()]
        public void PostNameTest()
        {
            BlogMLPost target = new BlogMLPost();

            string val = "Post Name";

            target.PostName = val;

            Assert.AreEqual(val, target.PostName, "BlogML.Xml.BlogMLPost.PostName was not set correctly.");
        }

        /// <summary>
        ///A test for PostType
        ///</summary>
        [TestMethod()]
        public void PostTypeTest()
        {
            BlogMLPost target = new BlogMLPost();

            BlogPostTypes val = BlogPostTypes.Normal;

            target.PostType = val;

            Assert.AreEqual(val, target.PostType, "BlogML.Xml.BlogMLPost.PostType was not set correctly.");

            target = new BlogMLPost();

            val = BlogPostTypes.Article;

            target.PostType = val;

            Assert.AreEqual(val, target.PostType, "BlogML.Xml.BlogMLPost.PostType was not set correctly.");
        }

        /// <summary>
        ///A test for PostUrl
        ///</summary>
        [TestMethod()]
        public void PostUrlTest()
        {
            BlogMLPost target = new BlogMLPost();

            string val = "http://nayyeri.net/archive/2007/06/28/nayyeri-net-turns-two.aspx";

            target.PostUrl = val;

            Assert.AreEqual(val, target.PostUrl, "BlogML.Xml.BlogMLPost.PostUrl was not set correctly.");
        }

        /// <summary>
        ///A test for Trackbacks
        ///</summary>
        [TestMethod()]
        public void TrackbacksTest()
        {
            BlogMLPost target = new BlogMLPost();

            BlogMLPost.TrackbackCollection val = new BlogMLPost.TrackbackCollection();

            BlogMLTrackback trackback1 = new BlogMLTrackback();
            trackback1.ID = "1";
            trackback1.Title = "Test1";
            trackback1.Url = "http://test1.com";
            target.Trackbacks.Add(trackback1);
            val.Add(trackback1);

            BlogMLTrackback trackback2 = new BlogMLTrackback();
            trackback2.ID = "2";
            trackback2.Title = "Test2";
            trackback2.Url = "http://test2.com";
            target.Trackbacks.Add(trackback2);
            val.Add(trackback2);

            Assert.AreEqual(val, target.Trackbacks, "BlogML.Xml.BlogMLPost.Trackbacks was not set correctly.");
        }

        /// <summary>
        ///A test for Views
        ///</summary>
        [TestMethod()]
        public void ViewsTest()
        {
            BlogMLPost target = new BlogMLPost();

            uint val = 456;

            target.Views = val;

            Assert.AreEqual(val, target.Views, "BlogML.Xml.BlogMLPost.Views was not set correctly.");
        }
    }
}
